/**
 * 	@class Pheme.controller.AdDebugSettings
 *  @extends Ext.app.Controller
 *  Description: Controller for the Ad Debugging settings
 */
Ext.define('Pheme.controller.AdDebugSettings', {
	extend: 'Ext.app.Controller',
	config: {
		refs: {
			debugButton: '#btn_debug',
			testAdButton: '#btn_testAds',
			sampleAdButton: '#btn_sampleAds',
			mainBottomAd: '#MainBottomAd',
			networkId: '#networkId',
			adButtonSettings: '#btn_ad_settings',
			adSet: '#DebugSettings',
		},
		control: {
			networkId: {
				action: function(field) {
					if(field.getValue().length > 0) {
						Pheme.helpers.DfpAds.setNetworkId(field.getValue());
					}
				}
			},
			adButtonSettings: { 
				tap: function() {
					this.getAdSet().isHidden() ? this.getAdSet().show() : this.getAdSet().hide();
				}
			},
			sampleAdButton: {
				tap: function() {
					(Pheme.helpers.DfpAds.getSampleAds()) ? this.getSampleAdButton().setText('Sample: Off') : this.getSampleAdButton().setText('Sample: On');
					Pheme.helpers.DfpAds.toggleSampleAds();
				}
			},
			debugButton: {
				tap: function() {
					(Pheme.helpers.DfpAds.getDebugMode()) ? this.getDebugButton().setText('Debug: Off') : this.getDebugButton().setText('Debug: On');
					Pheme.helpers.DfpAds.toggleDebugMode();
				}
			},
			testAdButton: {
				tap: function() {
					(Pheme.helpers.DfpAds.getTestAds()) ? this.getTestAdButton().setText('Test: Off') : this.getTestAdButton().setText('Test: On');
					Pheme.helpers.DfpAds.toggleTestAds();
				}
			}
		}
	},
});
