/**
 * 	@class Pheme.controller.AlertStory
 *  @extends Pheme.controller.GenericStory
 *  Description: Controller for the Breaking news story screens
 */
Ext.define('Pheme.controller.AlertStory', {
	extend: 'Pheme.controller.GenericStory',
	config: {
		refs: {
			toolbar: 'storytitlebar',
			storyCarousel: '#AlertStoryView'
		},
		control: {
            storyCarousel: {
				'story.link.tap': function(e) {
	                e.target.onclick = function() { return false };
	                e.stopEvent();
	                e.preventDefault();
	                e.stopPropagation();

	                Pheme.helpers.Common.linktapped(e.target, Ext.Viewport.getActiveItem().getActiveItem().internalId);
	            },
				show: function(self) {
					var me = this;
					try{
						var storyId = self.getStoryId();

						Pheme.helpers.Common.getStory(storyId, function(story) {
							// add story to carousel and activate it
							self.add(me.addStory(story, 'AlertStoryView'));
							self.setActiveItem(0);

							Pheme.helpers.Common.updateReadStory(storyId);
							Pheme.helpers.Common.autoRefreshApp();

	                    	Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true);
							
							Pheme.helpers.Omniture.pageView("alert story", story);
						});
					}
					catch(e){ console.log(e); }
				},
				hide: function(self) {
					self.removeAll(false, false);
				},

                activeitemchange: function(carousel, newActiveItem, oldActiveItem, eOpts) {
                    /*var storyId = newActiveItem.internalId;
                    var store = Ext.data.StoreManager.get(Pheme.app.currentStoryStore);
                    var retrievedStory = store.getById(storyId);*/
                }
			}
		}
	},
	/**
	 * [constructor description]
	 * @param  {[type]} config [description]
	 * @return {[type]}        [description]
	 */
	constructor: function(config) {
		this.initConfig(config);

        this.eventsQueue.push({ caller: 'AlertStoryView', eventTrigger: 'activeitemchange', functionToRun: Pheme.helpers.ControllerEvents.sendAnalytics, args: [] });
        this.eventsQueue.push({ caller: 'AlertStoryView', eventTrigger: 'activeitemchange', functionToRun: Pheme.helpers.ControllerEvents.renderAd, args: [] });
	},
	/**
	 * [init description]
	 * @return {[type]} [description]
	 */
	init: function() {
		this.callParent(arguments);
	}
});
