﻿/**
 *  @class Pheme.controller.App
 *  @extends Ext.app.Controller
 *  Description: Controller for the main app screen
 */
Ext.define('Pheme.controller.App', {
    extend: 'Ext.app.Controller',
    config: {
        toggleNavHidden: true,
        refs: {

            main: 'Main',
            bottomAd: '#MainBottomAd',
            menu: '#menuItems',
            navBtn: 'component[itemId=nav_btn]',
            viewport: 'Viewport',
            storiesList: '#storiesList'
        },
        control: {
            navBtn: {
                tap: function() {
                    Pheme.helpers.Omniture.pageEvent("Menu Icon Click", "main");
                    this.toggleNav();
                }
            },
            menu: {
                itemtap: 'toggleNav'
            },
            viewport: {
            //     'swipenav': 'toggleNav',
                activate: function() {
                    var mainEl = this.getMain().element;

                    if(!mainEl.hasCls('out') && !mainEl.hasCls('out-no-animation')) {
                        this.toggleDisplayAds();
                    }
                }
            }
        }
    },
    /**
     * [toggleNav description]
     * @return {[type]} [description]
     */
    toggleNav: function() {
        var storiesList = this.getStoriesList(),
            main = this.getMain().element;

        if(main.hasCls('out') || main.hasCls('out-no-animation')){
            Pheme.helpers.Common.switchElement(main);
            storiesList.getScrollable().getScroller().setDisabled(false);
            this.toggleDisplayAds();
		} else {
            Pheme.helpers.Common.switchElement(main, true);
            storiesList.getScrollable().getScroller().setDisabled(true);  
            Pheme.helpers.DfpAds.removeAds();
        }
    },
    /**
     * [toggleDisplayAds description]
     * @return {[type]} [description]
     */
    toggleDisplayAds: function() {
        var storiesList = this.getStoriesList(),
            story = storiesList.getStore().first();
        Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true);
    }

});
