/**
 *  @class Pheme.controller.FirstUse
 *  @extends Ext.app.Controller
 *  Description: Controller for the First Use Carousel
 */
Ext.define('Pheme.controller.FirstUse', {
    extend: 'Ext.app.Controller',
    requires: ['Pheme.view.FirstUse'],
    config: {
    	refs: {
    		firstUseStart: 'component[itemId=nav_start]'
    	},
	    control: {
	    	firstUseStart: {
	        	tap: function() { this.toMainView('#mainViewport'); }
	   		}
	   	}
    },
    /**
     * [toMainView description]
     * @param  {[type]} view [description]
     * @return {[type]}      [description]
     */
   	toMainView: function(view) {
   		if(Pheme.app.viewQueue.length > 0) {
   			// only using the first item in the queue...handle more in the future
   			Pheme.app.viewQueue[0]();

   			// reset queue
   			Pheme.app.viewQueue = [];
   		}
   		else {
   			Pheme.helpers.Common.switchView(view, { direction: 'left' });
   		}
           
        try {
            StatusBar.show();
            StatusBar.overlaysWebView(true);
        } catch(e) { }
    },
    /**
     * [constructor description]
     * @param  {[type]} config [description]
     * @return {[type]}        [description]
     */
    constructor: function(config) {
        this.initConfig(config);
    },
    /**
     * [init description]
     * @return {[type]} [description]
     */
    init: function() {
        this.callParent(arguments);
    }
});
