/**
 *  @class Pheme.controller.Main
 *  @extends Ext.app.Controller
 *  Description: Controller for the Main screen
 */
Ext.define('Pheme.controller.Main', {
	extend: 'Ext.app.Controller',
    config: {
		refs: {
			list: '#storiesList',
			main: 'Main',
			sv: '#StoryView',
			homeButton: '#main_nav_icon',
			updatedFollowCount: '#followingCountTitleBar',
            pullRefresh: '#pullRefresh'
		},
		control: {
			updatedFollowCount: {
				/**
				 * [initialize description]
				 * @param  {[type]} label [description]
				 * @param  {[type]} eOpts [description]
				 * @return {[type]}       [description]
				 */
				initialize: function(label, eOpts) {
					label.element.on('tap', function(b, e) {
						Pheme.helpers.FavoriteStories.showFavoriteView(); 
					});
				}
			},
			homeButton: {
				/**
				 * [tap description]
				 * @return {[type]} [description]
				 */
				tap: function() {
					this.getList().getScrollable().getScroller().scrollTo(0, 0);

					Pheme.helpers.Omniture.pageEvent("Home Icon Click", "main");
				}
			},
			list: {
				/**
				 * [itemtap description]
				 * @param  {[type]} list   [description]
				 * @param  {[type]} index  [description]
				 * @param  {[type]} target [description]
				 * @param  {[type]} record [description]
				 * @return {[type]}        [description]
				 */
				itemtap: function(list, index, target, record) {
					mainEl = this.getMain().element;
					if(mainEl.hasCls('out') || mainEl.hasCls('out-no-animation')) {
						Pheme.helpers.Common.switchElement(mainEl);
						Ext.getCmp('storiesList').getScrollable().getScroller().setDisabled(false);
						var story = list.getStore().first();
						Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true );
					}
					else {
						if(typeof record.isNativeAd != 'undefined' && record.isNativeAd) {
                            Pheme.helpers.Common.openInBrowser(record.data.permalink);
							Pheme.helpers.PolarAdsHelper.trackTapEvent(record.adModel, record.adtag, "Navigation - List View", {});
						}
						else {
	                        Pheme.app.currentStoryId = record.data.id;
	                        Pheme.app.currentStoryStore = 'Stories';
	                        Pheme.app.currentStoryIndex = index;
	                        Pheme.helpers.Common.switchView('#StoryView');
	                        Pheme.helpers.Omniture.pageEvent("Navigation - List View", "main");
	                        Pheme.helpers.Omniture.storyAction("Content Click", record);
	                    }
					}
				},
				/**
				 * [itemswipe description]
				 * @param  {[type]} self   [description]
				 * @param  {[type]} index  [description]
				 * @param  {[type]} target [description]
				 * @param  {[type]} record [description]
				 * @param  {[type]} e      [description]
				 * @param  {[type]} eOpts  [description]
				 * @return {[type]}        [description]
				 */
				itemswipe: function(self, index, target, record, e, eOpts) {
                    var main = this.getMain().element;
           
                    if (e.direction === 'left') {
						
						if(main.hasCls('out') || main.hasCls('out-no-animation')) {
							Pheme.helpers.Common.switchElement(main);
				            this.getList().getScrollable().getScroller().setDisabled(false);  
				            var storiesList = this.getList(),
					            story = storiesList.getStore().first();
					        Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true );
						}
						else {
							Pheme.app.currentStoryIndex = 0;
	                        Pheme.app.currentStoryId = null;
	                        Pheme.helpers.Common.switchElement(main, true);
	                        Pheme.helpers.Common.switchView('#StoryView');
	                        Pheme.helpers.Omniture.pageEvent("Navigation - Swipe", "main view");
	                	}
                    }
                    if (e.direction === 'right') {
                    	if(main.hasCls('out') || main.hasCls('out-no-animation')){
                    		Pheme.helpers.Common.switchElement(main);
				            this.getList().getScrollable().getScroller().setDisabled(false);
				            var storiesList = this.getList(),
					            story = storiesList.getStore().first();
					        Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true);
						} 
						else {
							Pheme.helpers.Common.switchElement(main, true);
				            this.getList().getScrollable().getScroller().setDisabled(true);  
				            Pheme.helpers.DfpAds.removeAds();
				        }
                    }
                },
                /**
                 * [activate description]
                 * @return {[type]} [description]
                 */
                activate: function() {
                    var topicsStore = Ext.getStore('topics');
                    this.refreshTopics(topicsStore);
                }
			},
            main: {
            	/**
            	 * [showInterstitial description]
            	 * @return {[type]} [description]
            	 */
                showInterstitial: function() {
                    if(!Pheme.app.displayedInterstitialAd) {
                        this.displayInterstitialAd();
                        this.setDisplayedInterstitialAd();
                    }
                },

                /**
                 * [displayNativeAd description]
                 * @return {[type]} [description]
                 */
                displayNativeAd: function() {
                	var storiesList = Ext.getCmp('storiesList'),
						story = storiesList.getStore().first();

                    Pheme.helpers.Common.requestNativeAd(story, true);
                }
            },
            pullRefresh: {
            	/**
            	 * [refreshTopics description]
            	 * @return {[type]} [description]
            	 */
                refreshTopics: function() {
                    var topicsStore = Ext.getStore('topics');
                    this.refreshTopics(topicsStore);

                    this.getList().setScrollToTopOnRefresh(false);
                    this.getList().refresh();
                    // if we don't set this back the pull to refresh gets screwed up
                    this.getList().setScrollToTopOnRefresh(true);

                    var storiesList = Ext.getCmp('storiesList'),
						story = storiesList.getStore().first();

                    Pheme.helpers.Common.requestNativeAd(story, true);
                }
            }
		}
	},
	/**
	 * [refreshTopics description]
	 * @param  {[type]} store [description]
	 * @return {[type]}       [description]
	 */
    refreshTopics: function(store) {
        store.load();
    },
    /**
     * [setDisplayedInterstitialAd description]
     */
    setDisplayedInterstitialAd: function() {
        Pheme.app.displayedInterstitialAd = true;
    },
    /**
     * [displayInterstitialAd description]
     * @return {[type]} [description]
     */
    displayInterstitialAd: function() {
    	var options = {
                'adUnitId': '/3081/' + Pheme.Config.fetchCurrentMarket().adCode + '.' + (Ext.os.is.iOS ? 'ip' : 'aroid') + '/prestitial',
                'tags': {
                    'pr': Pheme.Config.fetchCurrentMarket().adCode,
                    'imp': 'prestitial',
                    'nk': 'print',
                    'ck': 'prestitial',
                    'page': 'index',
                    'ver': '2' // ver=2 is already being set in DfpAds, but you dont see it when we spit out the debug info, so adding it here to avoid confusion with Ad Ops
                }
            };

    	if(Pheme.helpers.DfpAds.getTestAds()) {
            options.tags.test = 'yes';
        }

        if(Pheme.helpers.DfpAds.getDebugMode()) {
        	alert(JSON.stringify(options, null, 4));
        }

        Pheme.helpers.DfpAds.createInterstitialAd(options);
    }
});
