/**
 * 	@class Pheme.controller.NativeAd
 *  @extends Pheme.controller.GenericStory
 */
Ext.define('Pheme.controller.NativeAd', {
	extend: 'Ext.app.Controller',
	eventsQueue: [],
	config: {
		refs: {
			storyCarousel: '#NativeAdView'
		},
		control: {
            storyCarousel: {
				'story.link.tap': function(e) {
	                e.target.onclick = function() { return false };
	                e.stopEvent();
	                e.preventDefault();
	                e.stopPropagation();

	                Pheme.helpers.Common.openInBrowser(e.target.href);
	            },
				show: function(self) {
					try {
						if(self.getAdUrl()) {
							var adHtml = '<div class="scrolly"><iframe src="' + self.getAdUrl() + '" frameborder="0" width="100%" height="100%"></iframe></div>';
							
							var p = Ext.getCmp('nativead-panel');
							
							if(p) {
								p.setHtml(adHtml);
							} else {
								var adPanel = Ext.create('Ext.Panel', 
									{
										id: 'nativead-panel',
										html: adHtml
									}
								);

								self.add(adPanel);
							}

							Pheme.helpers.Common.autoRefreshApp();

		                    Pheme.helpers.DfpAds.removeAds();
		                }

                        setTimeout(function() {
                            Ext.getCmp('loadingMask').hide();
                        }, 3000);
					}
					catch(e){ console.log(e); }
				},
				hide: function(self) {
					self.removeAll(false, false);
				}
			}
		}
	},
	/**
	 * [constructor description]
	 * @param  {[type]} config [description]
	 * @return {[type]}        [description]
	 */
	constructor: function(config) {
		this.initConfig(config);

        this.eventsQueue.push({ caller: 'NativeAdView', eventTrigger: 'activeitemchange', functionToRun: Pheme.helpers.ControllerEvents.sendAnalytics, args: [] });
	},
	/**
	 * [init description]
	 * @return {[type]} [description]
	 */
	init: function() {
		this.callParent(arguments);
	}
});
