/**
 *  @class Pheme.controller.StoryTitleBar
 *  @extends Ext.app.Controller
 *  Description: Controller for the Title Bar functionality
 */
Ext.define('Pheme.controller.NativeAdTitleBar', {
    extend: 'Ext.app.Controller',
    config: {
    	refs: {
		    backButton: 'component[itemId=btn_back_native]',
	        alertButton: 'component[itemId=btn_alert_native]',
			alertModalView: '#FavoriteView',
			nativeAdView: '#NativeAdView',
			main: 'Main',
			updatedFollowCount: '#followingCountTitleBarStory'
		},
		control: {
			updatedFollowCount: {
				/**
				 * [initialize description]
				 * @param  {[type]} label [description]
				 * @param  {[type]} eOpts [description]
				 * @return {[type]}       [description]
				 */
				initialize: function(label, eOpts) {
					label.element.on('tap', function(b, e) {
						Pheme.helpers.FavoriteStories.showFavoriteView(); 
					});
				}
			},
	    	backButton: {
	    		/**
	    		 * [tap description]
	    		 * @return {[type]} [description]
	    		 */
	    		tap: function() {
	        		this.backToView('#mainViewport');

	        		var storiesList = Ext.getCmp('storiesList');
	        		storiesList.getScrollable().getScroller().setDisabled(false);
				}
	    	},
			alertButton: {
				/**
				 * [tap description]
				 * @param  {[type]} ) {            Pheme.helpers.FavoriteStories.showFavoriteView( [description]
				 * @return {[type]}   [description]
				 */
				tap: function() { Pheme.helpers.FavoriteStories.showFavoriteView(); }
			}
	    }
	},
	/**
	 * [backToView description]
	 * @param  {[type]} view [description]
	 * @return {[type]}      [description]
	 */
    backToView: function(view) {
    	Pheme.helpers.Common.switchElement(this.getMain().element, false, false);

		Pheme.helpers.Common.switchView(view, { direction: 'right' });
	},
    
    /**
     * [toMainView description]
     * @param  {[type]} view [description]
     * @return {[type]}      [description]
     */
    toMainView: function(view) {
        Pheme.helpers.Common.switchView(view, { direction: 'right' });
           
        try  {
            StatusBar.show();
            StatusBar.overlaysWebView(true);
        } 
        catch(e) {
           console.log(e);
        }
    }
});
