/**
 *  @class Pheme.controller.Navigation
 *  @extends Ext.app.Controller
 *  Description: Controller for the Navigation bar
 */
Ext.define('Pheme.controller.Navigation', {
    extend: 'Ext.app.Controller',
    config: {
        refs: {
            searchBox: '#searchbox',
            Footer: '#navFooter',
            About: '#AboutThisApp',
            menu: '#menuItems',
            main: 'Main',
            storiesList: '#storiesList',
            filterbar: '#filter_bar',
            bottomAd: '#MainBottomAd'
        },
        control: {
            searchBox: {
                /**
                 * [action description]
                 * @param  {[type]} field [description]
                 * @return {[type]}       [description]
                 */
                action: function(field) {
                    if(field.getValue().length > 0) {
                        Pheme.helpers.Common.switchView('#SearchView', { type: 'fade' });
                    }
                    else {
                        Pheme.helpers.Omniture.pageEvent("Null Search", "navigation");
                    }
                }
            },
            menu: {
                /**
                 * [itemtap description]
                 * @param  {[type]} list   [description]
                 * @param  {[type]} index  [description]
                 * @param  {[type]} target [description]
                 * @param  {[type]} record [description]
                 * @return {[type]}        [description]
                 */
                itemtap: function(list, index, target, record) {
                    var storiesList = this.getStoriesList();
                    var mainEl = this.getMain().element;
                    var filters = this.getFilterbar();
                    var store = Ext.getStore('Stories');
                    var bottomAd = this.getBottomAd();
                    var options;

                    bottomAd.hide();
                    
                    Pheme.helpers.Common.switchElement(mainEl);

                    // set filtered flag
                    Pheme.app.filterActive = true;

                    store.getProxy().setUrl(Pheme.Config.fetchCurrentMarket().endpoint + '/stories/' + record.data.slug);
                    store.loadPage(1, {callback: function(records, operation, success){
                            if(success){
                                Pheme.helpers.Common.requestNativeAd(records[0], true);
                                
                                filters.filterSlug = record.data.slug;
                                filters.getItems().items[0].setHtml(record.data.name);
                                filters.show();
                                storiesList.addCls("filtered");
                                var scroller = storiesList.getScrollable().getScroller();
                                scroller.setDisabled(false);
                                scroller.scrollTo(0, 0);

                                Pheme.helpers.Omniture.pageEvent("Filter Applied", "navigation", { section: record.data.name.toLowerCase() });
                            }
                            
                            Pheme.helpers.DfpAds.renderBannerAd(records[0], '#252525', true, true);
                        }
                    });
                },
                /**
                 * [itemswipe description]
                 * @param  {[type]} self   [description]
                 * @param  {[type]} index  [description]
                 * @param  {[type]} target [description]
                 * @param  {[type]} record [description]
                 * @param  {[type]} e      [description]
                 * @param  {[type]} eOpts  [description]
                 * @return {[type]}        [description]
                 */
                itemswipe: function(self, index, target, record, e, eOpts) {
                    if(e.direction == 'left' || e.direction == 'right') {
                        Pheme.helpers.Common.switchElement(this.getMain().element);
                        this.getStoriesList().getScrollable().getScroller().setDisabled(false);
                        var storiesList = this.getStoriesList(),
                        story = storiesList.getStore().first();
                        Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, true);
                    }
                }

            }
        }
    }
});