/**
 *  @class Pheme.controller.Search
 *  @extends Ext.app.Controller
 *  Description: Controller for the Search functionality
 */
Ext.define('Pheme.controller.Search', {
    extend: 'Ext.app.Controller',

    config: {
        refs: {
            list: '#searchResult',
            closeButton: '#btn_close_search',
            main: 'Main',
            searchbox: '#searchbox2',
            navSearchbox: '#searchbox',
            searchView: '#SearchView',
            resultCount: '#lb_resultCount',
            searchStoryView: '#SearchStoryView'
        },
        control: {
            list: {
                /**
                 * [itemtap description]
                 * @param  {[type]} list   [description]
                 * @param  {[type]} index  [description]
                 * @param  {[type]} target [description]
                 * @param  {[type]} record [description]
                 * @return {[type]}        [description]
                 */
                itemtap: function(list, index, target, record) {
                    if (record.data.type != 'storyline') 
                        var ref = window.open(encodeURI(record.data.permalink), '_blank', "location=yes,toolbar=yes,transitionstyle=fliphorizontal,presentationstyle=fullscreen,enableViewportScale=yes");
                    else { 
                        Pheme.app.currentStoryIndex = index;
                        var searchStoryView = this.getSearchStoryView();

                        searchStoryView.setStoryId(record.data.id);
                        searchStoryView.setStoreId('searchResult');
						Pheme.app.currentStoryStore = 'searchResult';

                        Pheme.helpers.Common.switchView('#SearchStoryView');
						

                        Pheme.helpers.Omniture.pageEvent("Navigation - List View", "search", { searchTerm: this.getSearchbox().getValue() }); 
                        Pheme.helpers.Omniture.storyAction("Content Click", record, { searchTerm: this.getSearchbox().getValue(), pageName: "search" })
                    }
                }
            },
            closeButton: {
                /**
                 * [tap description]
                 * @return {[type]} [description]
                 */
                tap: function() {
                    Pheme.helpers.Common.switchElement(this.getMain().element);
                    Pheme.helpers.Common.switchView('#mainViewport');
                    Ext.getCmp('storiesList').getScrollable().getScroller().setDisabled(false);
                    Ext.getStore('searchResult').removeAll(true);
                    this.getSearchbox().setValue('');
                }
            },
            searchbox: {
                /**
                 * [action description]
                 * @param  {[type]} searchbox [description]
                 * @return {[type]}           [description]
                 */
                action: function(searchbox){
                    if(searchbox.getValue().length > 0) {
                        this.search(searchbox.getValue());
                    }
                    else {
                        Pheme.helpers.Omniture.pageEvent("Null Search", "search");
                    }

                    this.getNavSearchbox().setValue(searchbox.getValue());
                },
                /**
                 * [clearicontap description]
                 * @return {[type]} [description]
                 */
                clearicontap: function(){
                    Ext.getStore('searchResult').removeAll();
                    this.getResultCount().setData({});
                }

            },
            searchView: {
                /**
                 * [activate description]
                 * @return {[type]} [description]
                 */
                activate: function(){
                    var searchTerm = this.getSearchbox().getValue();
                    if(!searchTerm || searchTerm.trim().length == 0) {
                        searchTerm = this.getNavSearchbox().getValue();
                        this.getSearchbox().setValue(searchTerm);
                        this.search(searchTerm);
                    }
                    else {
                        //Search call again because the Alert update changes the proxy URL for search
                        this.search(searchTerm);
                    }
                }
            }
        }
    },
    
    /**
     * [search description]
     * @param  {[type]} term [description]
     * @param  {[type]} page [description]
     * @return {[type]}      [description]
     */
    search: function(term, page){
        Pheme.helpers.Omniture.pageEvent("Internal Search", "search", { searchTerm: term });

        var searchStore = Ext.getStore('searchResult');
        var resultLabel = this.getResultCount();
        searchStore.removeAll();
        searchStore.getProxy().setUrl(Pheme.Config.fetchCurrentMarket().endpoint + '/search?s=' + encodeURIComponent(term));
        searchStore.loadPage(page || 1, { callback: function() {
            var firstRecord = searchStore.first();
            var counterLabel = '';

            if(firstRecord != null) {
                if(firstRecord.data.post_count != null) {
                    counterLabel = firstRecord.data.post_count;
                } else {
                    counterLabel = '&#160;';
                }
            }
            else {
                counterLabel = 0;
                Pheme.helpers.Omniture.pageEvent("Search Empty Results", "search", { searchTerm: term });
            }

            resultLabel.setData({count: counterLabel, label: 'search results'});
        }});
    }

});

