/**
 *  @class Pheme.controller.SearchStory
 *  @extends Pheme.controller.GenericStory
 *  Description: Controller for stories found via Search
 */
Ext.define('Pheme.controller.SearchStory', {
    extend: 'Pheme.controller.GenericStory',
    requires: ['Pheme.view.CustomCarousel'],
    config: {
        refs: {
            storyCarousel: '#SearchStoryView',
            storiesList: '#storiesList',
        },
        control: {
            storyCarousel: {
                /**
                 * [description]
                 * @param  {[type]} e [description]
                 * @return {[type]}   [description]
                 */
                'story.link.tap': function(e) {
                    e.target.onclick = function() {return false};
                    e.stopEvent();
                    e.preventDefault();
                    e.stopPropagation();

                    Pheme.helpers.Common.linktapped(e.target, Ext.Viewport.getActiveItem().getActiveItem().internalId);
                 },
                 /**
                  * [activate description]
                  * @param  {[type]} self         [description]
                  * @param  {[type]} viewport     [description]
                  * @param  {[type]} previousview [description]
                  * @param  {[type]} eOpts        [description]
                  * @return {[type]}              [description]
                  */
                 activate: function(self, viewport, previousview, eOpts) {
                     var currentStore = Ext.data.StoreManager.get(self.getStoreId()),
                        storyId = self.getStoryId();
                        Pheme.helpers.Common.updateReadStory(storyId);
                        searchStoryRecord = currentStore.getById(storyId);

                    self.add(this.addStory(searchStoryRecord, 'SearchStoryView'));
                 },
                 /**
                  * [show description]
                  * @param  {[type]} self [description]
                  * @return {[type]}      [description]
                  */
                 show: function(self) {
                     self.setActiveItem(0);
                 },
                 /**
                  * [hide description]
                  * @param  {[type]} carousel [description]
                  * @param  {[type]} eOpts    [description]
                  * @return {[type]}          [description]
                  */
                 hide: function(carousel, eOpts) {
                    carousel.removeAll(false, false);
                    carousel.setStoreId(undefined);
                    carousel.setStoryId(undefined);
                 },
                 /**
                  * [activeitemchange description]
                  * @param  {[type]} carousel      [description]
                  * @param  {[type]} newActiveItem [description]
                  * @param  {[type]} oldActiveItem [description]
                  * @param  {[type]} eOpts         [description]
                  * @return {[type]}               [description]
                  */
                 activeitemchange: function(carousel, newActiveItem, oldActiveItem, eOpts) {
                    var storyId = newActiveItem.internalId;
                    var store = Ext.data.StoreManager.get(Pheme.app.currentStoryStore);
                    var retrievedStory = store.getById(storyId); 
                }
            }
        }
    },
    /**
     * [constructor description]
     * @param  {[type]} config [description]
     * @return {[type]}        [description]
     */
    constructor: function(config) {
        this.initConfig(config);
        this.eventsQueue.push({ caller: 'SearchStoryView', eventTrigger: 'activeitemchange', functionToRun: Pheme.helpers.ControllerEvents.sendAnalytics, args: [] });
        this.eventsQueue.push({ caller: 'SearchStoryView', eventTrigger: 'activeitemchange', functionToRun: Pheme.helpers.ControllerEvents.renderAd, args: [] });
    },
    /**
     * [init description]
     * @return {[type]} [description]
     */
    init: function() {
        this.callParent(arguments);
    }
});
