/**
 *  ControllerEvents
 *  @class Pheme.helpers.ControllerEvents
 *  Description: ...
 */
Ext.define('Pheme.helpers.ControllerEvents', {
    singleton: true,
    config: {},
    /**
     * [getStoryFromStoryStoreById description]
     * @param  {[type]} storyId [description]
     * @param  {[type]} store   [description]
     * @return {[type]}         [description]
     */
    getStoryFromStoryStoreById: function(storyId, store) {
        if(undefined === storyId || undefined === store) {
            return null;
        }

        return store.getById(storyId);
    },
    /**
     * [getStoryObjectFromEventQueueArguments description]
     * @param  {[type]} args [description]
     * @return {[type]}      [description]
     */
    getStoryObjectFromEventQueueArguments: function(args) {

        if(undefined !== args) {
            var passedInArgumentsFromEventQueue = args,
                parentCarouselReferenceIndex = passedInArgumentsFromEventQueue.length - 1,
                storyCarouselObjects = passedInArgumentsFromEventQueue[parentCarouselReferenceIndex],
                storyId = storyCarouselObjects[storyCarouselObjects.length - 1].currentStoryId,
                retrievedStory = Pheme.helpers.ControllerEvents.getStoryFromStoryStoreById(storyId, this.retrieveCurrentStore());

            return retrievedStory;
        } else {
            return null;
        }

    },
    /**
     * [sendAnalytics description]
     * @return {[type]} [description]
     */
    sendAnalytics: function() {

        Pheme.helpers.Omniture.pageView("story", Pheme.helpers.ControllerEvents.getStoryObjectFromEventQueueArguments(arguments));
    },
    /**
     * [renderAd description]
     * @param  {[type]} store [description]
     * @return {[type]}       [description]
     */
    renderAd: function(store) {

        Pheme.helpers.ControllerEvents.renderBannerAd(Pheme.helpers.ControllerEvents.getStoryObjectFromEventQueueArguments(arguments));
    },
    /**
     * [renderBannerAd description]
     * @param  {[type]} story [description]
     * @return {[type]}       [description]
     */
    renderBannerAd: function(story) {
        if(story !== undefined) {
            Pheme.helpers.DfpAds.renderBannerAd(story, '#252525', true, false);
        } else {
            return null;
        }
    },
    /**
     * [retrieveCurrentStore description]
     * @return {[type]} [description]
     */
    retrieveCurrentStore: function() {
        return Ext.data.StoreManager.get(Pheme.app.currentStoryStore);
    }
});
