/*
 * User Settings Wrapper Class
 */
/**
 *  
 *  User Settings Wrapper Class
 *  @class Pheme.helpers.UserSettings
 *  Description: This class encapsulates the functionality for the User Settings
 */
Ext.define('Pheme.helpers.UserSettings', {
	singleton: true,
    /**
     * [get description]
     * @param  {[type]} key            [description]
     * @param  {[type]} defaultSetting [description]
     * @return {[type]}                [description]
     */
	get: function(key, defaultSetting) {
		var usStore = Ext.data.StoreManager.get('UserSettings');
		var record = usStore.findRecord("key", key);

        if(record == null) {
        	return (typeof defaultSetting != 'undefined') ? defaultSetting : null;
        }
        else {
        	return record.data.value;
        }
	},
    /**
     * [set description]
     * @param {[type]} key   [description]
     * @param {[type]} value [description]
     */
	set: function(key, value) {
		var usStore = Ext.data.StoreManager.get('UserSettings');

		var record = usStore.findRecord("key", key);

		if(record == null) {
        	record = usStore.add({ "key" : key, "value" : value });
        }
        else {
            record.set("value", value);
            record.dirty = true;
        }
        
        return record;
	},
	/**
     * [constructor description]
     * @param  {[type]} config [description]
     * @return {[type]}        [description]
     */
    constructor: function(config) {
        this.initConfig(config);
    },
    /**
     * [init description]
     * @return {[type]} [description]
     */
    init: function() {
        this.callParent(arguments);
    }
});