/**
 * @class Pheme.model.BreakingNews
 * @extends Ext.data.Model
 * Description: Store required fields of json feed from wp for Breaking News view
 */
Ext.define('Pheme.model.BreakingNews', {
	extend: 'Ext.data.Model',
	config: {
		fields: [
                  {name: 'id',  type: 'int'},
                  {name: 'title',   type: 'string'},
                  {name: 'content', type: 'auto'},
                  {name: 'excerpt', type: 'string'},
                  {name: 'featured_image_url',   type: 'string'},
                  {name: 'featured_image_url_x2',   type: 'string'},
                  {name: 'thumbnail_url',   type: 'string'},
                  {name: 'thumbnail_url_x2',   type: 'string'},
                  {name: 'permalink',   type: 'string'},
                  {name: 'last_modified', type: 'date'},
                  {name: 'date', type: 'date'},
                  // utc date from data feed gets converted to local time on device
                  {name: 'date_utc', type: 'date'},
                  {name: 'post_format', type: 'string'},
                  {name: 'categories', type: 'auto'},
                  {name: 'updated', type: 'boolean', convert: function(v, r) {
                      return Pheme.helpers.Common.checkIfUpdated(r.data.id, r.data.date_utc);
                  }},
                  {name: 'ad_codes', type: 'auto'},
                  {name: 'link', type: 'string'},
                  {name: 'breaking', type: 'boolean'}
		]
	}
});
