/**
 * @class Pheme.model.Search
 * @extends Ext.data.Model
 * Description: Model for search result feed for a given term.
 */
Ext.define('Pheme.model.Search', {
    extend: 'Ext.data.Model',
    config: {
        fields: [
            {name: 'id',  type: 'int'},
            {name: 'type',   type: 'string'},
            {name: 'permalink',   type: 'string'},
            {name: 'title',   type: 'string'},
            {name: 'author',   type: 'string'},
            {name: 'content', type: 'auto'},
            {name: 'excerpt', type: 'string'},
            {name: 'featured_image_url',   type: 'string'},
            {name: 'featured_image_url_x2',   type: 'string'},
            {name: 'thumbnail_url',   type: 'string'},
            {name: 'thumbnail_url_x2',   type: 'string'},
            {name: 'date', type: 'date'},
            // utc date from data feed gets converted to local time on device
            {name: 'date_utc', type: 'date'},
            {name: 'last_modified', type: 'date'},
            {name: 'position',  type: 'int'},
            {name: 'post_count',  type: 'int'},
            {name: 'categories',  type: 'auto'},
            {name: 'tags',  type: 'auto'},
            {name: 'topics',  type: 'auto'},
            {name: 'ad_codes', type: 'auto'},
            {name: 'updated', type: 'boolean', convert: function(v, r) {
                return Pheme.helpers.Common.checkIfUpdated(r.data.id, r.data.date_utc);
            }}
        ]
    }
});