/**
 * @class Pheme.model.Story
 * @extends Ext.data.Model
 * Description: Store required fields of json feed from wp for main story view.
 */
Ext.define('Pheme.model.Story', {
	extend: 'Ext.data.Model',
	config: {
        
        fields: [
            {name: 'id',  type: 'int'},
            {name: 'index', type: 'int'},
            {name: 'title',   type: 'string'},
            {name: 'content', type: 'auto'},
            {name: 'excerpt', type: 'string'},
            {name: 'categories',   type: 'auto'},
            {name: 'featured_image_url',   type: 'string'},
            {name: 'featured_image_url_x2',   type: 'string'},
            {name: 'thumbnail_url',   type: 'string'},
            {name: 'thumbnail_url_x2',   type: 'string'},
            {name: 'permalink',   type: 'string'},
            {name: 'last_modified', type: 'date'},
            {name: 'date', type: 'date'},
            // utc date from data feed gets converted to local time on device
            {name: 'date_utc', type: 'date'},
            {name: 'date_sort', type: 'date'},
            {name: 'date_favorited', type: 'date'},
			{name: 'post_format', type: 'string'},
            {name: 'updated', type: 'boolean', convert: function(v, r) {
                return Pheme.helpers.Common.checkIfUpdated(r.data.id, r.data.date_utc);
            }},
            {name: 'no_thumbnail', type: 'boolean'},
            {name: 'caption', type: 'string'},
            {name: 'credit', type: 'string'},
            {name: 'ad_codes', type: 'auto'},
            {name: 'main_ad_codes', type: 'auto'},
            {name: 'sponsor_prefix', type: 'string'},
            {name: 'sponsor_name', type: 'string'}
        ]
    }
});
