/**
 *  Stories
 *  @class Pheme.store.Stories
 *  @extends Ext.data.Store
 *  Description: ...
 */
Ext.define('Pheme.store.Stories', {
    extend: 'Ext.data.Store',
    requires: ['Ext.data.proxy.JsonP'],
    config: {
        model: 'Pheme.model.Story',
        storeId: 'Stories',
        mainAds: null,
        isIndexing: false,
        grouper: {
            groupFn: function (item) {
                return Ext.util.Format.date(item.get('date_sort'), "l, F j") + "<div class='arrow'></div>";
            },
            // sort data when we regroup / get new data from proxy
            sorterFn: function(item1, item2) {
                var date1 = Ext.util.Format.date(item1.data.date_sort, "Hi");
                var date2 = Ext.util.Format.date(item2.data.date_sort, "Hi");
                
                return date1 > date2 ? 1 : (date1 === date2 ? 0 : -1);
            },
            direction: 'DESC',
            groupDir: 'DESC'
        },
        proxy: {
            type: 'jsonp',
            timeout: 10000,
            noCache: false,
            url: Pheme.Config.fetchCurrentMarket().endpoint + '/stories',
            reader: {
                type: 'json'
            }
        },
        listeners: {
            load: function(store, records) {
                Pheme.helpers.Common.setStoryStoreRecordIndexes(store);  
            },
            addrecords: function(store, records) {
                Pheme.helpers.Common.setStoryStoreRecordIndexes(store);  
            },
            removerecords: function(store, records) {
                Pheme.helpers.Common.setStoryStoreRecordIndexes(store);  
            },
            updaterecord: function(me, record, newIndex, oldIndex, modifiedFieldNames, modifiedValues) {
                Pheme.helpers.Common.setStoryStoreRecordIndexes(me);  
            }
        }
    }
});
