/**
 *  Navigation
 *  @class Pheme.view.Navigation
 *  @extends Ext.Panel
 *  Description: ...
 */
Ext.define('Pheme.view.Navigation', {
    extend: 'Ext.Panel',
    xtype: 'navigation',
	id: 'NavigationView',
    requires: ['Ext.data.Store', 'Ext.field.Search', 'Ext.form.Panel'],
    config: {
        layout: 'vbox',
        cls: 'nav-panel',
        width: '275',
        items: [{
            xtype: 'titlebar',
			cls: 'search-nav',
            items: [{
                xtype: 'formpanel',
                layout: 'fit',
                items: [{
                    xtype: 'searchfield',
                    docked: 'top',
                    id: 'searchbox',
                    cls: 'search-box',
                    placeHolder: 'Search...',
                    name: 'query',
                    disabled: true, // to prevent keyboard from displaying without explicit tap
                    listeners: {
                      tap: {
                        element: 'element',
                        fn: function() {
                          Ext.getCmp('searchbox').setDisabled(false);
                          Ext.getCmp('navFooter').hide();
                        }
                      },
                      blur: function() {
                        Ext.getCmp('searchbox').setDisabled(true);
                        Ext.getCmp('navFooter').show();
                        }
                    }
                }]
            }]
        },
        {
            xtype: 'panel',
            cls: 'filter-box',
            html: '<h3 class="menu_title">Filter The List</h3>'
        }, 
        {
            xtype: 'list',
            flex: 1,
            disableSelection: true,
            id: 'menuItems',
			cls: 'list-items',
            store: 'topics',
            itemTpl: [' <div class="nav_items">', '<div class="left">{name}</div>', '</div>', '<div style="clear:both"></div>'].join(''),
            
        },
        {
            xtype: 'panel',
            docked: 'bottom',
            id: 'navFooter',
            layout: 'hbox',
            items: [
                {
                    xtype: 'label',
                    id: 'aboutLabel',
                    cls: 'nav_footer',
                    html: 'About This App ',
                    listeners: {
                        tap: {
                            element: 'element',
                            fn: function() {
                                Pheme.helpers.Common.switchView('#AboutThisApp', { direction: 'right' });
                            }
                        }
                    }
                },
                {
                    xtype: 'label',
                    id: 'privacyLabel',
                    cls: 'nav_footer',
                    html: ' Privacy Statement',
                    listeners: {
                        tap: {
                            element: 'element',
                            fn: function() {
                                window.open("http://www.postmedia.com/privacy-statement/", "_blank", "location=yes,toolbar=yes,transitionstyle=fliphorizontal,presentationstyle=fullscreen,enableViewportScale=yes");
                            }
                        }
                    }
                }
            ]
        }
        ]
    }
});
