/**
 *  Search
 *  @class Pheme.view.Search
 *  @extends Ext.Container
 *  Description: ...
 */
Ext.define('Pheme.view.Search', {
    extend: 'Ext.Container',
    requires: ['Pheme.plugin.CustomListPaging', 'Ext.plugin.PullRefresh', 'Ext.dataview.List', 'Ext.Label', 'Ext.form.Panel'],
    xtype: 'Search',
    id: 'SearchView',
    config: {
        layout: 'vbox',
        cls: 'search-panel',
        items: [{
            xtype: 'titlebar',
            docked: 'top',
            cls: 'search-view-titlebar',
            items: [
            {
                xtype: 'formpanel',
                cls: 'search-box view-search-box',
                items: [{
                    xtype: 'searchfield',
                    docked: 'top',
                    id: 'searchbox2',
                    placeHolder: ' Search...',
                    name: 'query2',
                    disabled: true, // to prevent keyboard from displaying without explicit tap
                    listeners: {
                      tap: {
                        element: 'element',
                        fn: function() {
                          Ext.getCmp('searchbox2').setDisabled(false);
                        }
                      },
                      blur: function() {
                        Ext.getCmp('searchbox2').setDisabled(true);
                      }
                    }
                }]
            },
            {
                xtype: 'image',
                cls: 'search-view-close',
                html: 'Cancel',
                id: 'btn_close_search',
            }]
        }, {
            xtype: 'label',
            id: 'lb_resultCount',
            cls: 'results-title',
            tpl: '{label}<div class="search-result-count">{count}</div>',
        }, {
            xtype: 'list',
            disableSelection: true,
            id: 'searchResult',
            loading: 'Searching...',
            scrollToTopOnRefresh: false,
            flex: 1,
            store: 'searchResult',
            cls: 'search-result',
            
            plugins: [
                {
                    xclass: 'Ext.plugin.PullRefresh',
                    pullText: 'Release to refresh...',
                    scrollerAutoRefresh: true,
                    autoSnapBack: true,
                    cls: 'pull-refresh-light',
                    listeners: {
                        'prefetchlatest' : function() {
                            // clear store and reload from the top
                            var store = Ext.getStore('searchResult');
                            store.data.clear();
                            store.sync();
                        },
                        'latestfetched' : function(pullRefresh) {
                            var store = Ext.getStore('searchResult');
                            store.loadPage(1);

                            pullRefresh.lastUpdated = new Date();
                        }
                    }
                },
                {
                    xclass: 'Pheme.plugin.CustomListPaging',
                    autoPaging: true,
                    bufferSize: 500,
                }
            ],

            itemTpl: ['<div class="search_results" data-id="{id}" data-url="{permalink}">', '<div>', '<h3>{title}</h3>', '<div class="sub">', '<tpl if="this.isFollowed(id)"><div class="following-star"></div></tpl><span class="timestamp"><tpl if="updated"><span class="updated">Updated </span></tpl><tpl if="date_utc != undefined">{date_utc:date("M j, Y g:i A")}<tpl else>{date:date("M j, Y g:i A")}</tpl> </span><tpl if="type != \'storyline\'"><span class="via">/ via ' + Pheme.Config.fetchCurrentMarket().paperWebsite + '</span></tpl>', '</div>', '</div>', '</div>', {

                isFollowed: function(id) {
                    return Pheme.helpers.FavoriteStories.isFavoriteStory(id);
                }
            }]
        }],
        listeners: {
            painted: function() {
                Pheme.helpers.Omniture.pageView("search");
                
                Pheme.helpers.DfpAds.removeAds();
            }
        }
    },

});