# Compile Configurations
environment = :production

# Note: primary=search bar background, secondary=search box color, tertiary=main toolbar
sass_options = { 
	:current_market => "calgary",

	:current_os => "ios",

	:markets => {
		"ottawa" => {
			"color_primary" => "#9ED2BE",
			"color_secondary" => "#8ec0ad",
			"color_tertiary" => "#78AA97",
			"color_alertbadge" => "#D45C21"
		},
		"montreal" => {
			"color_primary" => "#42A0D1",
			"color_secondary" => "#3390bc",
			"color_tertiary" => "#006DA4",
			"color_alertbadge" => "#D45C21"
		},
		"calgary" => {
			"color_primary" => "#5d8dc0",
			"color_secondary" => "#547fac",
			"color_tertiary" => "#3469a5",
			"color_alertbadge" => "#D45C21"
		},
		"edmontonjournal" => {
			"color_primary" => "#F9A755",
			"color_secondary" => "#e0964c",
			"color_tertiary" => "#DF6724",
			"color_alertbadge" => "#F9A755"
		},
		"windsorstar" => {
			"color_primary" => "#00589f",
			"color_secondary" => "#0063b0",
			"color_tertiary" => "#12347e",
			"color_alertbadge" => "#D45C21"
		}
	}
}

# Get the directory that this configuration file exists in
dir = File.dirname(__FILE__)

# Load sencha-touch themes
load File.join(dir, '../../touch/resources/themes')
load File.join(dir, 'boot')
load File.join(dir, 'market')
load File.join(dir, 'os')

# Path configurations
sass_path = dir
css_dir = File.join("..", "css")
images_dir = File.join("..", "images")
fonts_path = File.join("..", "fonts")

# Output configurations
output_style = (environment == :production) ? :compressed : :expanded 

# No comments
line_comments = false

# Functions for SASS
require File.join(dir, 'smartphone')

module Sass::Script::Functions
	include Smartphone
end
