StartTest(function(t) {
    var storyIds = [];

    var longDrag = function(next) {
        t.dragBy(Ext.Viewport.element, [0, -250], next);
    };

    var mediumDrag = function(next) {
        t.dragBy(Ext.Viewport.element, [0, -100], next);
    };

    var shortDrag = function(next) {
        t.dragBy(Ext.Viewport.element, [0, -20], next);
    };

    var addStoryIdToList = function(next) {
        var story = Ext.ComponentQuery.query('#StoryView');
        if(undefined === story[0].getActiveItem().aliases) {
            storyIds.push(story[0].getActiveItem().internalId);
        }

        next();
    };

    var checkForDuplicateStories = function(storyArray) {
        var placeHolder = storyArray.length,
            comparePlaceHolder;

        while(comparePlaceHolder=--placeHolder) {
            while(comparePlaceHolder--) {
                if(!(storyArray[placeHolder]!== storyArray[comparePlaceHolder])) {
                    return true;
                }
            }
        }

        return false;
    };

    var waitForMain = { waitFor: 'CQ', args: 'Main' };

    var wait = { waitFor: 1000 };

    var swipeLeft = { action: 'swipe', target: Ext.Viewport.element, direction: 'left' };

    var doStep = function(step) {
        return function(next) {
            step(next);
        }
    };

    t.chain(

        waitForMain,

        function(next) {
            t.ok(t.cq1('#main_nav_icon'), 'Should find main nav icon');
            t.moveCursorBy([100, 400]);
            next();
        },

        wait,

        doStep(longDrag),

        doStep(longDrag),

        doStep(longDrag),

        doStep(mediumDrag),

        doStep(shortDrag),

        {
            action: 'tap', target: '>> #storiesList > container > simplelistitem[id=ext-simplelistitem-9]'
        },

        wait,

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        doStep(addStoryIdToList),

        swipeLeft,

        function() {
            t.ok(!checkForDuplicateStories(storyIds));
        }
    );
});
