Ext.define('Pheme.Config', {
    singleton: true,

    config: {
        currentMarket: 'montreal',
        appVers: '1.1.4',

        markets: {
            ottawa: {
                resourcesDirectory: 'ottawa',
                endpoint: 'http://smrtphone.canada.com/ottawa',
                adCode: 'oc',
                distributor: 'ottawacitizen',
                newspaperBrand : 'ottawacitizen',
                aboutUs : 'Ottawa Citizen',
                paperWebsite: 'ottawacitizen.com'
            },
            montreal: {
                resourcesDirectory: 'montreal',
                endpoint: 'http://staging-smrtphone.herokuapp.com/mg-qa',
                adCode: 'mg',
                distributor: 'montrealgazette',
                newspaperBrand : 'montrealgazette',
                aboutUs : 'Montreal Gazette',
                paperWebsite: 'montrealgazette.com'
            },
            calgary: {
                resourcesDirectory: 'calgary',
                endpoint: 'http://smrtphone.canada.com/calgary',
                adCode: 'ch',
                distributor: 'calgaryherald',
                newspaperBrand : 'calgaryherald',
                aboutUs : 'Calgary Herald',
                paperWebsite: 'calgaryherald.com'
            }
        }
    },

    fetchCurrentMarket: function() {
        var currentMarket = this.getCurrentMarket();

        return this.getMarkets()[currentMarket];
    },
    fetchVersionNum: function(){
        return this.getAppVers();
    },
    constructor: function(config) {
        this.initConfig(config);
    },
    init: function() {
        this.callParent(arguments);
    }
});