describe('App Controller', function() {

    var app;

    beforeEach(function() {
        app = Ext.create('Ext.app.Application', {
            name: 'Pheme'
        });
    });

    describe('Toggling the Navigation Slide Out', function() {

        it('should not render an ad when the Navigation slide out is active', function() {

            var storyModel = Ext.create('Pheme.model.Story', { application: app }),
                storyStore = Ext.create('Pheme.store.Stories', { application: app }),
                stories = Ext.data.StoreManager.get('Stories');

            stories.load(function(self, records, successful, operation, eOpts) {
                var customList = Ext.create('Pheme.view.CustomList', { application: app }),
                    mainView = Ext.create('Pheme.view.Main', { application: app }),
                    navigationView = Ext.create('Pheme.view.Navigation', { application: app }),
                    viewport = Ext.create('Pheme.view.Viewport', { application: app }),
                    appController = Ext.create('Pheme.controller.App', { application: app });

                var DfpAds = Pheme.helpers.DfpAds;

                spyOn(DfpAds, 'renderBannerAd');

                appController.toggleNav();

                expect(DfpAds.renderBannerAd).not.toHaveBeenCalled();
            });
        });
    });

    afterEach(function() {
        app = undefined;
    });
});
