describe('Main Controller', function() {

    var app;

    beforeEach(function() {
        app = Ext.create('Ext.app.Application', {
            name: 'Pheme',
            displayedInterstitialAd: false
        });

        mainController = Ext.create('Pheme.controller.Main', { application: app });
    });

    describe('Displaying Prelaunch Interstitial', function() {
        it('should set the displayedInterstitialAd flag to true when showInterstitialAd is called', function() {
            mainController.setDisplayedInterstitialAd();

            //app.displayedInterstitialAd = true;
            expect(app.displayedInterstitialAd).toBe(true);
        });

        it('should call createInterstitialAd when displayInterstitialAd is called', function() {
            spyOn(Pheme.helpers.DfpAds, 'createInterstitialAd').and.callThrough();

            mainController.displayInterstitialAd();

            expect(Pheme.helpers.DfpAds.createInterstitialAd).toHaveBeenCalled();
        });
    });

    describe('Pulling to refresh', function() {

        /*it('should respond to pullRefresh event and call refreshTopics', function() {

            var mainView = Ext.create('Pheme.view.Main');

            spyOn(mainController, 'refreshTopics');

            //console.log(mainController.control('#pullRefresh'));

            //mainController.control.pullRefresh.refreshTopics();

            mainView.fireEvent('refreshTopics');

            expect(mainController.refreshTopics).toHaveBeenCalled();
        });*/

        it('should refresh the topics when the main list view is refreshed', function() {
            var topicsStore = {
                load: function() {
                    return true;
                }
            }

            spyOn(topicsStore, 'load').and.callThrough();

            mainController.refreshTopics(topicsStore);

            expect(topicsStore.load).toHaveBeenCalled();
        });
    });

    afterEach(function() {
        app = undefined;
        mainController = undefined;
    });
});
